! WHIZARD 1.12 Jun 20 2001
! 
! (C) 1999-2001 by Wolfgang Kilian <kilian@particle.uni-karlsruhe.de>
!
! WHIZARD is free software; you can redistribute it and/or modify it
! under the terms of the GNU General Public License as published by 
! the Free Software Foundation; either version 2, or (at your option)
! any later version.
!
! WHIZARD is distributed in the hope that it will be useful, but
! WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, write to the Free Software
! Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! This file has been stripped of most comments.  For documentation, refer
! to the source 'whizard.nw'

module jetset_interface

  use kinds, only: default !NODEP!
  use kinds, only: double !NODEP!
  use diagnostics, only: msg_error, msg_message

  implicit none
  private

  integer, parameter, public :: PYGIVE_LEN = 100

  public :: jetset_init, pythia_init
  public :: jetset_fragment
  public :: pythia_fragment
  public :: pythia_up_fill
  public :: jetset_write
  public :: jetset_suppress_banner

contains

  subroutine jetset_init (dummy)
    character(len=PYGIVE_LEN), intent(in) :: dummy
    call msg_error (" JETSET fragmentation is not available.")
    call msg_message &
         & (" To enable JETSET/PYTHIA, rerun configure and recompile WHIZARD.")
  end subroutine jetset_init

  subroutine pythia_init &
       & (dummy0, dummy1, dummy2, dummy3, dummy4, dummy5, dummy6)
    integer, intent(in) :: dummy0
    character(len=*), intent(in) :: dummy1, dummy2, dummy3
    real(kind=default), intent(in) :: dummy4, dummy5
    character(len=PYGIVE_LEN), intent(in) :: dummy6
    call msg_error (" PYTHIA fragmentation is not available.")
    call msg_message &
         & (" To enable PYTHIA, rerun configure and recompile WHIZARD.")
  end subroutine pythia_init

  subroutine jetset_fragment ()
  end subroutine jetset_fragment
  subroutine pythia_fragment
  end subroutine pythia_fragment
  subroutine pythia_up_fill (integral)
    real(kind=double), intent(out) :: integral
    integral = 0
  end subroutine pythia_up_fill

  subroutine jetset_write (mlist)
    integer, intent(in) :: mlist
    call msg_error ("PYTHIA event listing format is not available.")
    call msg_message ("To enable PYTHIA, rerun configure and recompile WHIZARD.")
  end subroutine jetset_write
  subroutine jetset_suppress_banner
  end subroutine jetset_suppress_banner

end module jetset_interface
